 @echo off
set projectPath="C:/UnrealProjects/ShotgoGame/ShotgoGame.uproject"
set stagingDirectory=E:/ShotgoBuilds/
set stagingPath=E:\ShotgoBuilds\

set EnginePath="C:\UnrealEngines\UE_4.20-Custom\"

set /p id="Enter Version: "
set /p choiceClient="Build client?(y): "

set /p choiceServer="Build and deploy server?(y): "
set /p choiceRelease="Zip and release to Github?(y): "

if '%choiceRelease%'=='n' goto client
echo "Creating Github release %id%"
github-release.exe release --user [username] --repo [reponame] --tag %id% --name "%id%" --security-token "[github security-token]" --pre-release

:client
if '%choiceClient%'=='n' goto server
echo Building client...

call %EnginePath%Engine\Build\BatchFiles\RunUAT.bat -ScriptsForProject=%projectPath% BuildCookRun -project=%projectPath% -noP4 -clientconfig=Development -serverconfig=Development -nocompile -nocompileeditor -installed -ue4exe=UE4Editor-Cmd.exe -utf8output -platform=Win64 -targetplatform=Win64 -build -cook -map=FirstPersonExampleMap+MenuMain+Greybox4 -unversionedcookedcontent -compressed -stage -package -stagingdirectory=%stagingDirectory% -cmdline=" -Messaging" -addcmdline="-SessionId= -SessionOwner='' -SessionName='Shotgo Client Windows' ";
copy /B /Y "%stagingPath%WindowsNoEditor\ShotgoGame.exe" "%stagingPath%WindowsNoEditor\SteamworksExample.exe" 

if '%choiceRelease%'=='n' goto server
start releaseClient.bat %stagingPath% %id%

:server
if '%choiceServer%'=='n' goto end
echo Building server...
call %EnginePath%Engine\Build\BatchFiles\RunUAT.bat -ScriptsForProject=%projectPath% BuildCookRun -project=%projectPath% -noP4 -clientconfig=Development -serverconfig=Development -nocompile -nocompileeditor -installed -ue4exe=UE4Editor-Cmd.exe -utf8output -server -serverplatform=Linux -noclient -build -cook -map=EmptyMap+FirstPersonExampleMap+Greybox4 -unversionedcookedcontent -compressed -stage -package -stagingdirectory=%stagingDirectory% -cmdline=" -Messaging" -addcmdline="-SessionId= -SessionOwner='' -SessionName='Shotgo Dedicated Server Linux' ";
start deployServer.bat

if '%choiceRelease%'=='n' goto end
del "%stagingPath%ServerBuild.zip"
"C:\Program Files\WinRAR\Rar.exe" a -ep1 -r %stagingDirectory%ServerBuild.zip %stagingDirectory%LinuxServer/
echo "Uploading to Github release"
github-release.exe upload --user [username] --repo [reponame] --tag %id% --name "ShotgoServer%id%.zip" --file %stagingDirectory%ServerBuild.zip --security-token "[github security-token]"


:end
echo Build deployment finished
pause